#include "xtama_init.h"

void main(argc, argv)
int argc;
char **argv;
{
  int i , ii , j ;
  int screen , display_width, display_height , default_depth ;
  char display_name[10] , buffer[20] , colorbuffer[20] , *tmp ;
  XWindowAttributes root_attr;
  XpmAttributes xpm_attr;  XSetWindowAttributes xset_attr;
  Pixmap back3 , back1 ;
  Font font ;
  unsigned long values ;
  Window root ;
  Bool isserver , Install = False ;

  int iro_data[12][3] = {
    { 0 , 0 , 255 } ,
    { 0 , 255 , 0 } ,
    { 255 , 255 , 0} ,
    { 255 , 0 , 0 } ,
    { 255 , 255 , 255},
    { 0 , 0 , 0 },
    {255 , 114 , 107 },
    {25 , 0 , 250},
    {238 , 238 , 0},
    {32 , 208 , 32},
    {125 , 0 , 150}
  } ;

  char *tama_iro[] = { 
    ".	c #FF726B",
    ".	c #1900FA",
    ".	c #eeee00",
    ".	c #20cc20",
    ".	c #7D0096",
  } ;

  XColor  colordef;
  XVisualInfo vtmp , * vlist ;
  int vism ;
  

  display_name[0] = (char)NULL ;
  buffer[0] = (char)NULL ;
  erase = ERASE ;
  mouse = net = False ;
    
  for ( i = 0 ; i < 3 ; i ++ )
    mous[i] = i + 1 ;

  i = 1 ;
  ii = 0 ;
  while( i < argc ){
    if ( !strcmp("-display",argv[i] )){
      strcpy( display_name , argv[++i] ) ;
      i ++ ;
      continue ;
    }
    if ( !strcmp("-rensa",argv[i] )){
      if ( ( erase = atoi(argv[++i])) < 2 )
	erase = 2 ;
      erase -- ;
      i ++ ;
      continue ;
    }
    if ( !strcmp("-install" , argv[i] )){
      Install = True ;
      i ++ ;
      continue ;
    }
    if ( !strcmp("-mouse",argv[i])){
      mouse = True;
      i ++ ;
      continue ;
    }
    if ( !strcmp("-fall",argv[i] )){
      mous[FALL] = atoi( argv[++ i]) ;
      i ++ ;
      continue ;
    }
    if ( !strcmp("-lturn",argv[i] )){
      mous[LTURN] = atoi( argv[++ i]) ;
      i ++ ;
      continue ;
    }
    if ( !strcmp("-rturn",argv[i] )){
      mous[RTURN] = atoi( argv[++ i]) ;
      i ++ ;
      continue ;
    }
#ifdef NET
    if ( !strcmp("-host" ,argv[i] )){
      i ++ ;
      tmp = argv[i] ;
      isserver = False ;
      net = True ;
      i ++ ;
      continue ;
    }
    if ( !strcmp("-net",argv[i])){
      net = True ;
      isserver = True ;
      i ++ ;
      continue ;
    }
#endif
    usage(argv[0]) ;
  }
  
  dpy = XOpenDisplay(display_name);
  if (dpy == NULL) {
    fprintf(stderr, "PuzzleTama:  unable to open display '%s'\n",
            XDisplayName(display_name));
    return;
  }

#ifdef NET
  if ( net ){
    net_init( isserver , tmp ) ;
    while( ( fdc = dup( sockfd )) < 0 ) ;
    signal(SIGKILL,quit) ;
    signal(SIGTERM,quit) ;
  }
#endif

    screen = DefaultScreen( dpy ) ;
 
  
  vtmp.screen = screen ;
  vtmp.depth = 8 ;
  vtmp.class = PseudoColor ;

  vlist = XGetVisualInfo( dpy , VisualScreenMask|VisualDepthMask|
			 VisualClassMask , &vtmp , &vism ) ;
  
  if ( vism == 0 )
    printf("No matching visual \n") ;
  
  if ( Install ) cmap = XCreateColormap(dpy, XDefaultRootWindow( dpy ),vlist[0].visual  , AllocNone);
  else cmap = DefaultColormap( dpy , screen ) ;
  
  if (XAllocColorCells( dpy , cmap , True, NULL, 0,
		       iro , 12)) {
    colordef.flags = DoRed | DoGreen | DoBlue;
    for (i = 0; i < 12; i++) {
      colordef.pixel = iro[i] ;
      colordef.red =  iro_data[i][0] * 256 ;
      colordef.green = iro_data[i][1] * 256 ;
      colordef.blue = iro_data[i][2] * 256 ;
      XStoreColor( dpy, cmap, &colordef);
    }
  }
  else printf("Can't allocate \n") ;
  

  gc = DefaultGC(dpy, DefaultScreen(dpy));

  screen = DefaultScreen(dpy);
  root = RootWindow(dpy, screen);

  display_width  = DisplayWidth(dpy, screen);
  display_height = DisplayHeight(dpy, screen);
  default_depth = DefaultDepth(dpy, screen);

  srand((int)time((time_t *)NULL));

  /* initiate windows */
  
  frame =  XCreateSimpleWindow(dpy, root, 0, 0, 
			       ( net ? 830 : 500 ) , 550,0, 1, 1);
  
  XSetWindowColormap( dpy , frame , cmap) ;

  back =  XCreateSimpleWindow(dpy, frame, 10, 35, 
			      320 , 480 ,0, 1, BlackPixel(dpy,0));
  
  vsback =  XCreateSimpleWindow(dpy, frame, 500, 35, 
			      320 , 480 ,0, iro[BLACK], iro[BLACK]);

  score =  XCreateSimpleWindow(dpy, frame, 340, 10, 
			       150 , 530,0, 1, WhitePixel(dpy , screen));
  
  sele =  XCreateSimpleWindow(dpy, frame , 0, 0, 
				200 , 100 , 0 , iro[WHITE] , iro[WHITE] ) ; 
  
  /* create pixmaps from data files */
  
  XGetWindowAttributes(dpy, frame, &root_attr);

  xpm_attr.colormap = root_attr.colormap;
  xpm_attr.valuemask = XpmSize | XpmReturnPixels | XpmColormap;
  
  
  XpmCreatePixmapFromData(dpy, frame, (char **)&back4_xpm,
                          &back_xpm, NULL, &xpm_attr);
  
  XpmCreatePixmapFromData(dpy, frame, (char **)&back2,
                          &back1, NULL, &xpm_attr);
  
  for ( i = 0 ; i < 5 ; i ++ )
    {
      sprintf( colorbuffer , "%s\0" , tama_iro[ i ] ) ;
      
      ball_xpm_data[ 2 ] = colorbuffer ;
      XpmCreatePixmapFromData(dpy, frame, (char **)ball_xpm_data ,
			      &ball[i], &vmask[0], &xpm_attr) ;
      
      mini_ball_xpm_data[ 2 ] = colorbuffer ;
      XpmCreatePixmapFromData(dpy, frame, (char **)mini_ball_xpm_data ,
			      &ball[7+i], &vmask[1], &xpm_attr) ;
      
      
      grow1_xpm[2] = colorbuffer ;
      XpmCreatePixmapFromData(dpy, frame, (char **)grow1_xpm , 
			      &animation[i][0] ,
			      &animation_mask[0] , &xpm_attr ) ; 
      
      grow2_xpm[2] = colorbuffer ;
      XpmCreatePixmapFromData(dpy, frame, (char **)grow2_xpm , 
			      &animation[i][1] ,
			      &animation_mask[1] , &xpm_attr ) ; 
      
      grow3_xpm[2] = colorbuffer ;
      XpmCreatePixmapFromData(dpy, frame, (char **)grow3_xpm , 
			      &animation[i][2] ,
			      &animation_mask[2] , &xpm_attr ) ; 
      
      grow4_xpm[2] = colorbuffer ;
      XpmCreatePixmapFromData(dpy, frame, (char **)grow4_xpm , 
			      &animation[i][3] ,
			      &animation_mask[3] , &xpm_attr ) ; 
      
      grow5_xpm[2] = colorbuffer ;
      XpmCreatePixmapFromData(dpy, frame, (char **)grow5_xpm , 
			      &animation[i][4] ,
			      &animation_mask[4] , &xpm_attr ) ; 
    }
  

  XpmCreatePixmapFromData(dpy, back, (char **)white_xpm,
			  &ball[5], NULL, &xpm_attr);
  
  XpmCreatePixmapFromData(dpy, back, (char **)black_xpm,
			  &ball[6], NULL, &xpm_attr);
  
  XpmCreatePixmapFromData(dpy, frame, (char **)title_xpm,
			  &titl_xpm, &title_msk, &xpm_attr);
  
  XpmCreatePixmapFromData(dpy, score, (char **)title2_xpm,
			  &titl2_xpm, &title2_msk, &xpm_attr);
  
  XpmCreatePixmapFromData(dpy, score, (char **)tama_xpm,
			  &char_xpm, &char_msk, &xpm_attr);

  XpmCreatePixmapFromData(dpy, frame, (char **)tama1_xpm,
			  &tama[0], &tama[1], &xpm_attr);

  XpmCreatePixmapFromData(dpy, frame, (char **)tama2_xpm,
			  &tama[2], &tama[3], &xpm_attr);

  XpmCreatePixmapFromData(dpy, score, (char **)back5_xpm,
			  &back3, NULL, &xpm_attr);

  XpmCreatePixmapFromData(dpy, back, (char **)flush1_xpm,
			  &pdemo[0], &pdemo_mask[0], &xpm_attr);

  XpmCreatePixmapFromData(dpy, back, (char **)flush2_xpm,
			  &pdemo[1], &pdemo_mask[1], &xpm_attr);

  XpmCreatePixmapFromData(dpy, back, (char **)flush3_xpm,
			  &pdemo[2], &pdemo_mask[2], &xpm_attr);
  
  XpmCreatePixmapFromData(dpy, back, (char **)Bwhite_xpm,
			  &effect[0], &effect[1], &xpm_attr);
  
  XpmCreatePixmapFromData(dpy, back, (char **)Eblack_xpm,
			  &effect[2], &effect[3], &xpm_attr);
 
  /* change some windows's Attribute of BackingStore */


  XSetWindowBackgroundPixmap(dpy, frame, back_xpm);

  XSetWindowBackgroundPixmap(dpy, back, back3);
  XSetWindowBackgroundPixmap(dpy, vsback, back3);
  XSetWindowBackgroundPixmap(dpy, score , back1);

  XStoreName( dpy , frame , "PuzzleTama") ;

  
  XSetForeground( dpy , gc , iro[BLUE] );

  sele_xpm[0] = XCreatePixmapFromBitmapData( dpy , sele , sl_attc_bits ,
					sl_attc_width , sl_attc_height ,
					    iro[YELLOW] , iro[BLACK] , default_depth ) ;

  sele_xpm[2] = XCreatePixmapFromBitmapData( dpy , sele , sl_scor_bits ,
					sl_scor_width , sl_scor_height ,
					    iro[BLUE] ,iro[WHITE]  , default_depth ) ;
  
  sele_xpm[1] = XCreatePixmapFromBitmapData( dpy , sele , sl_prac_bits ,
					sl_prac_width , sl_prac_height ,
					    iro[GREEN] ,iro[WHITE]  , default_depth ) ;

  sele_xpm[3] = XCreatePixmapFromBitmapData( dpy , sele , sl_quit_bits ,
					    sl_quit_width , sl_quit_height ,
					    iro[BLACK] , iro[WHITE] , default_depth ) ;
  
#ifdef NET

  sele_xpm[4] = XCreatePixmapFromBitmapData( dpy , sele , sl_taisen_bits ,
					sl_taisen_width , sl_taisen_height ,
					    iro[BLUE] , iro[YELLOW] , default_depth ) ;

  over[2] = XCreateBitmapFromData( dpy , sele , winner_bits ,
					winner_width , winner_height ) ;
  
  over[1] = XCreateBitmapFromData( dpy , sele , loser_bits ,
					loser_width , loser_height ) ;

#endif
 
  over[0] = XCreateBitmapFromData( dpy , sele , gameover_bits ,
				  gameover_width , gameover_height ) ;
  
  font=XLoadFont(dpy,"-*-*-bold-o-*-*-24-*-*-*-p-*-iso8859-1" );
  
  XSetFont( dpy , gc , font ) ;

  
  for ( i = 0 ; i < 4 ; i ++ )
    spa[i] = XCreatePixmap( dpy , back , 320 , 480 , default_depth ) ;
  
  tama_title() ;
  }
  
  void usage(char *name)
{
  printf("usage: %s [options]\n",name ) ;
  printf("  -display  display  ǥץ쥤ꤹ\n") ;
  printf("  -rensa    n      ĤǾä뤫\n");
  printf("                     (ϿΤϣĤλΤ)\n");
  printf("  -install           顼ޥåפ򥤥󥹥ȡ\n");
  printf("  -mouse             ޥ\n");
#ifdef NET
  printf("  -net               魯˵ưͤꤹ\n") ;
  printf("  -host     ۥ   魯˵ưͤ˵ưͤ\n");
  printf("                     ۥ̾ꤹ\n");
#endif
  printf("ޥΥܥѹ\n");
  printf("  -rturn ܥֹ  ǥեȤǤϣ\n") ;
  printf("  -fall  ܥֹ  ǥեȤǤϣ\n") ;
  printf("  -lturn ܥֹ  ǥեȤǤϣ\n") ;
 
  exit(0);
}

#ifdef NET

void quit ()
{
  
  char mess[10] ;
  if ( writen( sockfd , "qBreak\n" , 7 ) != strlen(mess) )
    err_sys("str_cli: writen error on socket") ;
  printf("close .\n");
  shutdown(sockfd,2) ;
  XCloseDisplay( dpy ) ;
  close(sockfd) ;
  exit(0);
}

#endif
